SystemOrganization addCategory: #SMIME!
SystemOrganization addCategory: #'SMIME-CMS'!

Object subclass: #CMSAttribute
	instanceVariableNames: 'attrType attrValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSAttribute methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:50'!
attrType
	"Answer the value of attrType"

	^ attrType! !

!CMSAttribute methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:50'!
attrType: anObject
	"Set the value of attrType"

	attrType := anObject! !

!CMSAttribute methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:50'!
attrValues
	"Answer the value of attrValues"

	^ attrValues! !

!CMSAttribute methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:50'!
attrValues: anObject
	"Set the value of attrValues"

	attrValues := anObject! !

Object subclass: #CMSContentInfo
	instanceVariableNames: 'contentType content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSContentInfo class methodsFor: 'class initialization' stamp: 'rww 4/13/2007 16:48'!
initialize

	CMSContentInfo initializeASN1Types.
	CMSSignedData initializeASN1Types.
	CMSEnvelopedData initializeASN1Types.
	CMSEncryptedData initializeASN1Types.
! !

!CMSContentInfo class methodsFor: 'class initialization' stamp: 'rww 4/13/2007 16:51'!
initializeASN1Types

	| module |
	module := ASN1Module name: #cms.
	module addImport: (ASN1Module name: #x509).

	(module sequence: #ContentInfo mapping: CMSContentInfo)
		add: #contentType type: #ContentType;
		add: #content type: #ContentInfoContents explicitTag: 0;
		yourself.
	module objectIdentifier: #ContentType.
	(module any: #ContentInfoContents definedBy: #contentType)
		at: (ASN1ObjectId fromString: '1.2.840.113549.1.7.1') put: #ASN1ByteArrayType;
		at: (ASN1ObjectId fromString: '1.2.840.113549.1.7.2') put: #SignedData;
		at: (ASN1ObjectId fromString: '1.2.840.113549.1.7.3') put: #EnvelopedData;
		at: (ASN1ObjectId fromString: '1.2.840.113549.1.7.5') put: #DigestedData;
		at: (ASN1ObjectId fromString: '1.2.840.113549.1.7.6') put: #EncryptedData;
		at: (ASN1ObjectId fromString: '1.2.840.113549.1.9.16.1.2') put: #AuthenticatedData;
		yourself.
! !

!CMSContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 22:01'!
content
	"Answer the value of content"

	^ content! !

!CMSContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 22:01'!
content: anObject
	"Set the value of content"

	content := anObject! !

!CMSContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 22:01'!
contentType
	"Answer the value of contentType"

	^ contentType! !

!CMSContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 22:01'!
contentType: anObject
	"Set the value of contentType"

	contentType := anObject! !

Object subclass: #CMSEncapsulatedContentInfo
	instanceVariableNames: 'eContentType eContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSEncapsulatedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:01'!
eContent
	"Answer the value of eContent"

	^ eContent! !

!CMSEncapsulatedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:01'!
eContent: anObject
	"Set the value of eContent"

	eContent := anObject! !

!CMSEncapsulatedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:01'!
eContentType
	"Answer the value of eContentType"

	^ eContentType! !

!CMSEncapsulatedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:01'!
eContentType: anObject
	"Set the value of eContentType"

	eContentType := anObject! !

Object subclass: #CMSEncryptedContentInfo
	instanceVariableNames: 'contentType contentEncryptionAlgorithm encryptedContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSEncryptedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:00'!
contentEncryptionAlgorithm
	"Answer the value of contentEncryptionAlgorithm"

	^ contentEncryptionAlgorithm! !

!CMSEncryptedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:00'!
contentEncryptionAlgorithm: anObject
	"Set the value of contentEncryptionAlgorithm"

	contentEncryptionAlgorithm := anObject! !

!CMSEncryptedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:00'!
contentType
	"Answer the value of contentType"

	^ contentType! !

!CMSEncryptedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:00'!
contentType: anObject
	"Set the value of contentType"

	contentType := anObject! !

!CMSEncryptedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:00'!
encryptedContent
	"Answer the value of encryptedContent"

	^ encryptedContent! !

!CMSEncryptedContentInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:00'!
encryptedContent: anObject
	"Set the value of encryptedContent"

	encryptedContent := anObject! !

Object subclass: #CMSEncryptedData
	instanceVariableNames: 'version encryptedContentInfo unprotectedAttrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSEncryptedData class methodsFor: 'class initialization' stamp: 'rww 4/13/2007 16:50'!
initializeASN1Types

	| module |
	module := ASN1Module name: #cms.

	(module sequence: #EncryptedData mapping: CMSEncryptedData)
		add: #version type: #ASN1IntegerType;
		add: #encryptedContentInfo type: #EncryptedContentInfo;
		yourself.
	(module sequence: #EncryptedContentInfo mapping: CMSEncryptedContentInfo)
		add: #contentType type: #ContentType;
		add: #contentEncryptionAlgorithm type: #AlgorithmIdentifier;
		addOptional: #encryptedContent type: #EncryptedContent implicitTag: 0;
		yourself.
	module byteArray: #EncryptedContent.
! !

!CMSEncryptedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:55'!
encryptedContentInfo
	"Answer the value of encryptedContentInfo"

	^ encryptedContentInfo! !

!CMSEncryptedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:55'!
encryptedContentInfo: anObject
	"Set the value of encryptedContentInfo"

	encryptedContentInfo := anObject! !

!CMSEncryptedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:55'!
unprotectedAttrs
	"Answer the value of unprotectedAttrs"

	^ unprotectedAttrs! !

!CMSEncryptedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:55'!
unprotectedAttrs: anObject
	"Set the value of unprotectedAttrs"

	unprotectedAttrs := anObject! !

!CMSEncryptedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:55'!
version
	"Answer the value of version"

	^ version! !

!CMSEncryptedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 08:55'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #CMSEnvelopedData
	instanceVariableNames: 'version originatorInfo recipientInfos encryptedContentInfo unprotectedAttrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSEnvelopedData class methodsFor: 'class initialization' stamp: 'rww 4/14/2007 11:57'!
initializeASN1Types

	| module |
	module := ASN1Module name: #cms.

	(module sequence: #EnvelopedData mapping: CMSEnvelopedData)
		add: #version type: #CMSVersion;
		addOptional: #originatorInfo type: #OriginatorInfo implicitTag: 0;
		add: #recipientInfos type: #RecipientInfos;
		add: #encryptedContentInfo type: #EncryptedContentInfo;
		addOptional: #unprotectedAttrs type: #UnprotectedAttributes implicitTag: 1;
		yourself.

	(module sequence: #OriginatorInfo mapping: CMSOriginatorInfo)
		addOptional: #certs type: #CertificateSet implicitTag: 0;
		addOptional: #crls type: #RevocationInfoChoices implicitTag: 1;
		yourself.

	module set: #RecipientInfos of: #RecipientInfo.
	module set: #UnprotectedAttributes of: #Attribute.

	(module choice: #RecipientInfo)
		add: #ktri type: #KeyTransRecipientInfo;
		add: #kari type: #KeyAgreeRecipientInfo;
		add: #kekri type: #KEKRecipientInfo;
		add: #pwri type: #PasswordRecipientInfo;
		add: #ori type: #OtherRecipientInfo;
		yourself.

	(module sequence: #KeyTransRecipientInfo mapping: CMSKeyTransRecipientInfo)
		add: #version type: #CMSVersion;
		add: #rid type: #RecipientIdentifier;
		add: #keyEncryptionAlgorithm type: #KeyEncryptionAlgorithmIdentifier;
		add: #encryptedKey type: #EncryptedKey;
		yourself.
	module byteArray: #EncryptedKey.
	(module choice: #RecipientIdentifier)
		add: #issuerAndSerialNumber type: #IssuerAndSerialNumber;
		add: #subjectKeyIdentifier type: #SubjectKeyIdentifier implicitTag: 0;
		yourself.
	module assign: #KeyEncryptionAlgorithmIdentifier from: #AlgorithmIdentifier.
! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
encryptedContentInfo
	"Answer the value of encryptedContentInfo"

	^ encryptedContentInfo! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
encryptedContentInfo: anObject
	"Set the value of encryptedContentInfo"

	encryptedContentInfo := anObject! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
originatorInfo
	"Answer the value of originatorInfo"

	^ originatorInfo! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
originatorInfo: anObject
	"Set the value of originatorInfo"

	originatorInfo := anObject! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
recipientInfos
	"Answer the value of recipientInfos"

	^ recipientInfos! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
recipientInfos: anObject
	"Set the value of recipientInfos"

	recipientInfos := anObject! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
unprotectedAttrs
	"Answer the value of unprotectedAttrs"

	^ unprotectedAttrs! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
unprotectedAttrs: anObject
	"Set the value of unprotectedAttrs"

	unprotectedAttrs := anObject! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
version
	"Answer the value of version"

	^ version! !

!CMSEnvelopedData methodsFor: 'accessing' stamp: 'rww 4/13/2007 09:01'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #CMSIssuerAndSerialNumber
	instanceVariableNames: 'issuer serialNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSIssuerAndSerialNumber class methodsFor: 'instance creation' stamp: 'rww 4/20/2007 09:46'!
certificate: cert

	^ self new
		issuer: cert tbsCertificate issuer;
		serialNumber: cert tbsCertificate serialNumber;
		yourself.
! !

!CMSIssuerAndSerialNumber methodsFor: 'accessing' stamp: 'rww 4/14/2007 10:57'!
issuer
	"Answer the value of issuer"

	^ issuer! !

!CMSIssuerAndSerialNumber methodsFor: 'accessing' stamp: 'rww 4/14/2007 10:57'!
issuer: anObject
	"Set the value of issuer"

	issuer := anObject! !

!CMSIssuerAndSerialNumber methodsFor: 'accessing' stamp: 'rww 4/14/2007 10:57'!
serialNumber
	"Answer the value of serialNumber"

	^ serialNumber! !

!CMSIssuerAndSerialNumber methodsFor: 'accessing' stamp: 'rww 4/14/2007 10:57'!
serialNumber: anObject
	"Set the value of serialNumber"

	serialNumber := anObject! !

Object subclass: #CMSKEKRecipientInfo
	instanceVariableNames: 'version kekid keyEncryptionAlgorithm encryptedKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
encryptedKey
	"Answer the value of encryptedKey"

	^ encryptedKey! !

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
encryptedKey: anObject
	"Set the value of encryptedKey"

	encryptedKey := anObject! !

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
kekid
	"Answer the value of kekid"

	^ kekid! !

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
kekid: anObject
	"Set the value of kekid"

	kekid := anObject! !

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
keyEncryptionAlgorithm
	"Answer the value of keyEncryptionAlgorithm"

	^ keyEncryptionAlgorithm! !

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
keyEncryptionAlgorithm: anObject
	"Set the value of keyEncryptionAlgorithm"

	keyEncryptionAlgorithm := anObject! !

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
version
	"Answer the value of version"

	^ version! !

!CMSKEKRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:28'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #CMSKeyAgreeRecipientInfo
	instanceVariableNames: 'version originator userKeyingMaterial keyEncryptionAlgorithm recipientEncryptedKeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
keyEncryptionAlgorithm
	"Answer the value of keyEncryptionAlgorithm"

	^ keyEncryptionAlgorithm! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
keyEncryptionAlgorithm: anObject
	"Set the value of keyEncryptionAlgorithm"

	keyEncryptionAlgorithm := anObject! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
originator
	"Answer the value of originator"

	^ originator! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
originator: anObject
	"Set the value of originator"

	originator := anObject! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
recipientEncryptedKeys
	"Answer the value of recipientEncryptedKeys"

	^ recipientEncryptedKeys! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
recipientEncryptedKeys: anObject
	"Set the value of recipientEncryptedKeys"

	recipientEncryptedKeys := anObject! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
userKeyingMaterial
	"Answer the value of userKeyingMaterial"

	^ userKeyingMaterial! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
userKeyingMaterial: anObject
	"Set the value of userKeyingMaterial"

	userKeyingMaterial := anObject! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
version
	"Answer the value of version"

	^ version! !

!CMSKeyAgreeRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:26'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #CMSKeyTransRecipientInfo
	instanceVariableNames: 'version rid keyEncryptionAlgorithm encryptedKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
encryptedKey
	"Answer the value of encryptedKey"

	^ encryptedKey! !

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
encryptedKey: anObject
	"Set the value of encryptedKey"

	encryptedKey := anObject! !

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
keyEncryptionAlgorithm
	"Answer the value of keyEncryptionAlgorithm"

	^ keyEncryptionAlgorithm! !

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
keyEncryptionAlgorithm: anObject
	"Set the value of keyEncryptionAlgorithm"

	keyEncryptionAlgorithm := anObject! !

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
rid
	"Answer the value of rid"

	^ rid! !

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
rid: anObject
	"Set the value of rid"

	rid := anObject! !

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
version
	"Answer the value of version"

	^ version! !

!CMSKeyTransRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:27'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #CMSOriginatorInfo
	instanceVariableNames: 'certs crls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSOriginatorInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 17:05'!
certs
	"Answer the value of certs"

	^ certs! !

!CMSOriginatorInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 17:05'!
certs: anObject
	"Set the value of certs"

	certs := anObject! !

!CMSOriginatorInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 17:05'!
crls
	"Answer the value of crls"

	^ crls! !

!CMSOriginatorInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 17:05'!
crls: anObject
	"Set the value of crls"

	crls := anObject! !

Object subclass: #CMSOtherCertificateFormat
	instanceVariableNames: 'otherCertFormat otherCert'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSOtherCertificateFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:24'!
otherCert
	"Answer the value of otherCert"

	^ otherCert! !

!CMSOtherCertificateFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:24'!
otherCert: anObject
	"Set the value of otherCert"

	otherCert := anObject! !

!CMSOtherCertificateFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:24'!
otherCertFormat
	"Answer the value of otherCertFormat"

	^ otherCertFormat! !

!CMSOtherCertificateFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:24'!
otherCertFormat: anObject
	"Set the value of otherCertFormat"

	otherCertFormat := anObject! !

Object subclass: #CMSOtherRecipientInfo
	instanceVariableNames: 'oriType oriValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSOtherRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:30'!
oriType
	"Answer the value of oriType"

	^ oriType! !

!CMSOtherRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:30'!
oriType: anObject
	"Set the value of oriType"

	oriType := anObject! !

!CMSOtherRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:30'!
oriValue
	"Answer the value of oriValue"

	^ oriValue! !

!CMSOtherRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:30'!
oriValue: anObject
	"Set the value of oriValue"

	oriValue := anObject! !

Object subclass: #CMSOtherRevocationInfoFormat
	instanceVariableNames: 'otherRevInfoFormat otherRevInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSOtherRevocationInfoFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:25'!
otherRevInfo
	"Answer the value of otherRevInfo"

	^ otherRevInfo! !

!CMSOtherRevocationInfoFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:25'!
otherRevInfo: anObject
	"Set the value of otherRevInfo"

	otherRevInfo := anObject! !

!CMSOtherRevocationInfoFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:25'!
otherRevInfoFormat
	"Answer the value of otherRevInfoFormat"

	^ otherRevInfoFormat! !

!CMSOtherRevocationInfoFormat methodsFor: 'accessing' stamp: 'rww 4/13/2007 13:25'!
otherRevInfoFormat: anObject
	"Set the value of otherRevInfoFormat"

	otherRevInfoFormat := anObject! !

Object subclass: #CMSPasswordRecipientInfo
	instanceVariableNames: 'version keyDerivationAlgorithm keyEncryptionAlgorithm encryptedKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
encryptedKey
	"Answer the value of encryptedKey"

	^ encryptedKey! !

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
encryptedKey: anObject
	"Set the value of encryptedKey"

	encryptedKey := anObject! !

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
keyDerivationAlgorithm
	"Answer the value of keyDerivationAlgorithm"

	^ keyDerivationAlgorithm! !

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
keyDerivationAlgorithm: anObject
	"Set the value of keyDerivationAlgorithm"

	keyDerivationAlgorithm := anObject! !

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
keyEncryptionAlgorithm
	"Answer the value of keyEncryptionAlgorithm"

	^ keyEncryptionAlgorithm! !

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
keyEncryptionAlgorithm: anObject
	"Set the value of keyEncryptionAlgorithm"

	keyEncryptionAlgorithm := anObject! !

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
version
	"Answer the value of version"

	^ version! !

!CMSPasswordRecipientInfo methodsFor: 'accessing' stamp: 'rww 4/13/2007 20:29'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #CMSSignedData
	instanceVariableNames: 'version digestAlgorithms encapContentInfo certificates crls signerInfos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSSignedData class methodsFor: 'class initialization' stamp: 'rww 4/16/2007 02:58'!
initializeASN1Types

	| module |
	module := ASN1Module name: #cms.

	(module sequence: #SignedData mapping: CMSSignedData)
		add: #version type: #CMSVersion;
		add: #digestAlgorithms type: #DigestAlgorithmIdentifiers;
		add: #encapContentInfo type: #EncapsulatedContentInfo;
		addOptional: #certificates type: #CertificateSet implicitTag: 0;
		addOptional: #crls type: #RevocationInfoChoices implicitTag: 1;
		add: #signerInfos type: #SignerInfos;
		yourself.
	module integer: #CMSVersion.
	module set: #DigestAlgorithmIdentifiers of: #DigestAlgorithmIdentifier.
	module assign: #DigestAlgorithmIdentifier from: #AlgorithmIdentifier.
	(module sequence: #EncapsulatedContentInfo mapping: CMSEncapsulatedContentInfo)
		add: #eContentType type: #ContentType;
		addOptional: #eContent type: #ASN1ByteArrayType explicitTag: 0;
		yourself.

	module set: #SignerInfos of: #SignerInfo.
	(module sequence: #SignerInfo mapping: CMSSignerInfo)
		add: #version type: #CMSVersion;
		add: #sid type: #SignerIdentifier;
		add: #digestAlgorithm type: #DigestAlgorithmIdentifier;
		addOptional: #signedAttrs type: #SignedAttributes implicitTag: 0;
		add: #signatureAlgorithm type: #SignatureAlgorithmIdentifier;
		add: #signature type: #SignatureValue;
		addOptional: #unsignedAttrs type: #UnsignedAttributes implicitTag: 1;
		yourself.
	(module choice: #SignerIdentifier)
		add: #issuerAndSerialNumber type: #IssuerAndSerialNumber;
		add: #subjectKeyIdentifier type: #SubjectKeyIdentifier;
		yourself.
	(module sequence: #IssuerAndSerialNumber mapping: CMSIssuerAndSerialNumber)
		add: #issuer type: #Name;
		add: #serialNumber type: #CertificateSerialNumber;
		yourself.
	module byteArray: #SubjectKeyIdentifier.
	module set: #SignedAttributes of: #Attribute.
	module assign: #SignatureAlgorithmIdentifier from: #AlgorithmIdentifier.
	module byteArray: #SignatureValue.
	module set: #UnsignedAttributes of: #Attribute.

	(module sequence: #Attribute mapping: CMSAttribute)
		add: #attrType type: #ASN1ObjectIdentifierType;
		add: #attrValues type: #AttributeValues;
		yourself.
	module set: #AttributeValues of: #AttributeValue.
	module any: #AttributeValue.

	module set: #CertificateSet of: #CertificateChoices.
	(module choice: #CertificateChoices)
		add: #certificate type: #Certificate;
		add: #extendedCertificate type: #ExtendedCertificate implicitTag: 0;
		add: #v1AttrCert type: #AttributeCertificateV1 implicitTag: 1;
		add: #v2AttrCert type: #AttributeCertificateV2 implicitTag: 2;
		add: #other type: #OtherCertificateFormat implicitTag: 3;
		yourself.
	module assign: #AttributeCertificateV2 from: #AttributeCertificate.
	(module sequence: #OtherCertificateFormat mapping: CMSOtherCertificateFormat)
		add: #otherCertFormat type: #ASN1ObjectIdentifierType;
		add: #otherCert type: #OtherCertAny;
		yourself.
	(module any: #OtherCertAny definedBy: #otherCertFormate)
		yourself.

	module set: #RevocationInfoChoices of: #RevocationInfoChoice.
	(module choice: #RevocationInfoChoice)
		add: #crl type: #CertificateList;
		add: #other type: #OtherRevocationInfoFormat implicitTag: 1;
		yourself.
	(module sequence: #OtherRevocationInfoFormat mapping: CMSOtherRevocationInfoFormat)
		add: #otherRevInfoFormat type: #ASN1ObjectIdentifierType;
		add: #otherRevInfo type: #OtherRevInfoAny;
		yourself.
	(module any: #OtherRevInfoAny definedBy: #otherRevInfoFormat)
		yourself.
! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
certificates
	"Answer the value of certificates"

	^ certificates! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
certificates: anObject
	"Set the value of certificates"

	certificates := anObject! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
crls
	"Answer the value of crls"

	^ crls! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
crls: anObject
	"Set the value of crls"

	crls := anObject! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
digestAlgorithms
	"Answer the value of digestAlgorithms"

	^ digestAlgorithms! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
digestAlgorithms: anObject
	"Set the value of digestAlgorithms"

	digestAlgorithms := anObject! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
encapContentInfo
	"Answer the value of encapContentInfo"

	^ encapContentInfo! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
encapContentInfo: anObject
	"Set the value of encapContentInfo"

	encapContentInfo := anObject! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
signerInfos
	"Answer the value of signerInfos"

	^ signerInfos! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
signerInfos: anObject
	"Set the value of signerInfos"

	signerInfos := anObject! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
version
	"Answer the value of version"

	^ version! !

!CMSSignedData methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:43'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #CMSSignerInfo
	instanceVariableNames: 'version sid digestAlgorithm signedAttrs signatureAlgorithm signature unsignedAttrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME-CMS'!

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
digestAlgorithm
	"Answer the value of digestAlgorithm"

	^ digestAlgorithm! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
digestAlgorithm: anObject
	"Set the value of digestAlgorithm"

	digestAlgorithm := anObject! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
sid
	"Answer the value of sid"

	^ sid! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
sid: anObject
	"Set the value of sid"

	sid := anObject! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
signature
	"Answer the value of signature"

	^ signature! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
signature: anObject
	"Set the value of signature"

	signature := anObject! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
signatureAlgorithm
	"Answer the value of signatureAlgorithm"

	^ signatureAlgorithm! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
signatureAlgorithm: anObject
	"Set the value of signatureAlgorithm"

	signatureAlgorithm := anObject! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
signedAttrs
	"Answer the value of signedAttrs"

	^ signedAttrs! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
signedAttrs: anObject
	"Set the value of signedAttrs"

	signedAttrs := anObject! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
unsignedAttrs
	"Answer the value of unsignedAttrs"

	^ unsignedAttrs! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
unsignedAttrs: anObject
	"Set the value of unsignedAttrs"

	unsignedAttrs := anObject! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
version
	"Answer the value of version"

	^ version! !

!CMSSignerInfo methodsFor: 'accessing' stamp: 'rww 4/12/2007 13:45'!
version: anObject
	"Set the value of version"

	version := anObject! !

Object subclass: #SMIMEAgent
	instanceVariableNames: 'certStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME'!

!SMIMEAgent methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:40'!
certStore
	"Answer the value of certStore"

	^ certStore! !

!SMIMEAgent methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:40'!
certStore: anObject
	"Set the value of certStore"

	certStore := anObject! !

!SMIMEAgent methodsFor: 'api' stamp: 'rww 4/20/2007 09:53'!
encrypt: mailMsg

	| contentInfo bodyText newMsg |
	contentInfo := self envelopedContentInfoFrom: mailMsg.
	bodyText := ASN1Stream 
		encode: contentInfo 
		withType: ((ASN1Module name: #cms) find: #ContentInfo).
	
	newMsg := MailMessage empty.
	newMsg body: (MIMEDocument 
		contentType: 'application/pkcs7-mime' 
		content: bodyText asString).
	newMsg setField: 'content-type' to: ((MIMEHeaderValue fromMIMEHeader: 'application/pkcs7-mime')
		parameterAt: 'name' put: 'smime.p7m';
		parameterAt: 'smime-type' put: 'enveloped-data';
		yourself).
	newMsg setField: 'content-disposition' to: ((MIMEHeaderValue fromMIMEHeader: 'attachment')
		parameterAt: 'filename' put: 'smime.p7m';
		yourself).
	newMsg setField: 'content-transfer-encoding' to: (MIMEHeaderValue fromMIMEHeader: 'base64').
	newMsg setField: 'mime-version' to: (MIMEHeaderValue fromMIMEHeader: '1.0').
	newMsg setField: 'from' to: (MIMEHeaderValue fromMIMEHeader: mailMsg from).
	newMsg setField: 'to' to: (MIMEHeaderValue fromMIMEHeader: mailMsg to).
	newMsg setField: 'subject' to: (MIMEHeaderValue fromMIMEHeader: mailMsg subject).
	newMsg regenerateText.

	^ newMsg
! !

!SMIMEAgent methodsFor: 'private' stamp: 'rww 4/20/2007 09:53'!
envelopedContentInfoFrom: mailMsg

	| contentEncryptionKey iv tdes encrypted encryptedContentInfo envelopedData addresses certs publicKey encryptedKey recipientInfo contentInfo |
	contentEncryptionKey := SecureRandom new nextBytesNonZero: 24.
	iv := SecureRandom new nextBytesNonZero: 8.
	tdes := (TripleDES key: contentEncryptionKey) cbc initialVector: iv copy.
	encrypted := tdes encrypt: mailMsg text withInternetLineEndings asByteArray.

	encryptedContentInfo := CMSEncryptedContentInfo new
		contentType: (ASN1ObjectId fromString: '1.2.840.113549.1.7.1');
		contentEncryptionAlgorithm: (X509AlgorithmIdentifier oidString: '1.2.840.113549.3.7' parameters: iv);
		encryptedContent: encrypted;
		yourself.
	envelopedData := CMSEnvelopedData new
		version: 0;
		recipientInfos: Set new;
		encryptedContentInfo: encryptedContentInfo;
		yourself.

	addresses := MailAddressParser addressesIn: mailMsg to.
	addresses do: [:eachAddr |
		certs := self certStore atEmail: eachAddr.
		publicKey := certs first tbsCertificate subjectPublicKeyInfo asPublicKey.
		encryptedKey := publicKey v15Encrypt: contentEncryptionKey.
		recipientInfo := CMSKeyTransRecipientInfo new
			version: 0;
			rid: (CMSIssuerAndSerialNumber certificate: certs first);
			keyEncryptionAlgorithm: (X509AlgorithmIdentifier oidString: '1.2.840.113549.1.1.1' parameters: ASN1Null new);
			encryptedKey: encryptedKey;
			yourself.
		envelopedData recipientInfos add: recipientInfo].

	contentInfo := CMSContentInfo new
		contentType: (ASN1ObjectId fromString: '1.2.840.113549.1.7.3');
		content: envelopedData;
		yourself.
	^ contentInfo
! !

!SMIMEAgent methodsFor: 'initialize-release' stamp: 'rww 4/18/2007 11:40'!
initialize

	self certStore: SMIMECertificateStore new.
! !

!SMIMEAgent methodsFor: 'private' stamp: 'rww 4/18/2007 11:54'!
processEncrypted: mailMsg

	| contentInfo recipientInfo contentEncryptionKey iv tdes decrypted |
	contentInfo := ASN1Stream 
		decodeBytes: mailMsg body content asByteArray
		withType: ((ASN1Module name: #cms) find: #ContentInfo).
	recipientInfo := contentInfo content recipientInfos 
		detect: [:e | e rid serialNumber = self certStore ownerCert tbsCertificate serialNumber]
		ifNone: [^ self error: 'no matching certificate'].
	contentEncryptionKey := self certStore ownerPrivateKey v15Decrypt: recipientInfo encryptedKey.
	iv := contentInfo content encryptedContentInfo contentEncryptionAlgorithm parameters.
	tdes := (TripleDES key: contentEncryptionKey) cbc initialVector: iv copy.
	decrypted := tdes decrypt: contentInfo content encryptedContentInfo encryptedContent.
	^ (MailMessage from: decrypted asString withSqueakLineEndings)
		parseParts;
		yourself.
! !

!SMIMEAgent methodsFor: 'api' stamp: 'rww 4/15/2007 18:54'!
processMsg: mailMsg

	| newMailMsg |
	mailMsg body contentType = 'application/pkcs7-mime'
		ifTrue: [
			newMailMsg := self processEncrypted: mailMsg.
			^ self processMsg: newMailMsg].
	mailMsg body contentType = 'multipart/signed'
		ifTrue: [
			newMailMsg := self processSigned: mailMsg.
			^ newMailMsg].
	^ mailMsg
! !

!SMIMEAgent methodsFor: 'private' stamp: 'rww 4/22/2007 13:39'!
processSigned: mailMsg

	| textMsg sigMsg contentInfo textDigest signedDigest cert publicKey signedAttrsDer hashAttr certs fromEmails |
	textMsg := mailMsg parts 
		detect: [:e | e body contentType = 'text/plain'] 
		ifNone: [nil].
	sigMsg := mailMsg parts 
		detect: [:e | e body contentType = 'application/pkcs7-signature'] 
		ifNone: [nil].

	contentInfo := ASN1Stream 
		decodeBytes: sigMsg body content asByteArray
		withType: ((ASN1Module name: #cms) find: #ContentInfo).
	certs := contentInfo content certificates asOrderedCollection.
	fromEmails := MailAddressParser addressesIn: mailMsg from.
	fromEmails do: [:fromEmail |
		self certStore atEmail: fromEmail putCerts: certs].

	cert := certs first.
	publicKey := cert tbsCertificate subjectPublicKeyInfo asPublicKey.
	textDigest := SHA1 hashMessage: textMsg text withInternetLineEndings.
	contentInfo content signerInfos do: [:eachSignerInfo |
		hashAttr := eachSignerInfo signedAttrs
			detect: [:eachAttr | eachAttr attrType oid = '1.2.840.113549.1.9.4']
			ifNone: [nil].
		hashAttr notNil ifTrue: [
			hashAttr attrValues asOrderedCollection first = textDigest
				ifFalse: [^ 'bad message hash']].
		signedAttrsDer := (ASN1Stream 
			encode: eachSignerInfo signedAttrs
			withType: ((ASN1Module name: #cms) find: #SignedAttributes)).
		signedAttrsDer at: 1 put: 49.
		signedDigest := SHA1 hashMessage: signedAttrsDer.
		signedDigest := OrderedCollection new
			add: (OrderedCollection new 
				add: (ASN1ObjectId fromString: '1.3.14.3.2.26'); 
				add: nil; 
				yourself);
			add: signedDigest;
			asAsn1Bytes.
		(publicKey 
			v15VerifySignature: eachSignerInfo signature 
			ofMessageHash: signedDigest)
				ifFalse: [^ 'bad message hash']].
	^ mailMsg
! !

!SMIMEAgent methodsFor: 'api' stamp: 'rww 4/23/2007 18:14'!
sign: mailMsg

	| textMsg contentInfo bodyText sigMsg newMsg |
	textMsg := MailMessage empty.
	textMsg body: (MIMEDocument 
		contentType: 'text/plain' 
		content: mailMsg body contents).
	textMsg setField: 'content-transfer-encoding' to: (MIMEHeaderValue fromMIMEHeader: '7bit').
	textMsg setField: 'content-type' to: ((MIMEHeaderValue fromMIMEHeader: 'text/plain')
		parameterAt: 'charset' put: 'US-ASCII';
		parameterAt: 'format' put: 'flowed';
		yourself).

	contentInfo := self signedContentInfoFrom: textMsg.
	bodyText := ASN1Stream 
		encode: contentInfo 
		withType: ((ASN1Module name: #cms) find: #ContentInfo).

	sigMsg := MailMessage empty.
	sigMsg body: (MIMEDocument 
		contentType: 'application/pkcs7-signature' 
		content: bodyText asString).
	sigMsg setField: 'content-transfer-encoding' to: (MIMEHeaderValue fromMIMEHeader: 'base64').
	sigMsg setField: 'content-type' to: ((MIMEHeaderValue fromMIMEHeader: 'application/pkcs7-signature')
		parameterAt: 'name' put: 'smime.p7s';
		yourself).
	sigMsg setField: 'content-disposition' to: ((MIMEHeaderValue fromMIMEHeader: 'attachment')
		parameterAt: 'filename' put: 'smime.p7s';
		yourself).

	newMsg := MailMessage empty.
	newMsg parts: (OrderedCollection with: textMsg with: sigMsg).
	newMsg setField: 'content-type' to: ((MIMEHeaderValue fromMIMEHeader: 'multipart/signed')
		parameterAt: 'micalg' put: 'sha1';
		parameterAt: 'boundary' put: MailMessage generateSeparator;
		parameterAt: 'protocol' put: 'application/pkcs7-signature';
		yourself).
	newMsg setField: 'mime-version' to: (MIMEHeaderValue fromMIMEHeader: '1.0').
	newMsg setField: 'date' to: (MIMEHeaderValue fromMIMEHeader: DateAndTime now printMIMEDayDateAndTime).
	newMsg setField: 'from' to: (MIMEHeaderValue fromMIMEHeader: mailMsg from).
	newMsg setField: 'to' to: (MIMEHeaderValue fromMIMEHeader: mailMsg to).
	newMsg setField: 'subject' to: (MIMEHeaderValue fromMIMEHeader: mailMsg subject).
	newMsg regenerateBodyFromParts.
	newMsg regenerateText.

	^ newMsg
! !

!SMIMEAgent methodsFor: 'private' stamp: 'rww 4/23/2007 19:23'!
signedContentInfoFrom: mailMsg

	| textDigest signerInfo attr signedAttrsDer signedDigest signedData contentInfo |
	textDigest := SHA1 hashMessage: mailMsg text withInternetLineEndings.

	signerInfo := CMSSignerInfo new.
	signerInfo version: 1.
	signerInfo sid: (CMSIssuerAndSerialNumber certificate: self certStore ownerCert).
	signerInfo digestAlgorithm: (X509AlgorithmIdentifier oidString: '1.3.14.3.2.26' parameters: ASN1Null new).
	signerInfo signedAttrs: OrderedCollection new.
	attr := CMSAttribute new
		attrType: (ASN1ObjectId fromString: '1.2.840.113549.1.9.3');
		attrValues: (Set with: (ASN1ObjectId fromString: '1.2.840.113549.1.7.1'));
		yourself.
	signerInfo signedAttrs add: attr.
	attr := CMSAttribute new
		attrType: (ASN1ObjectId fromString: '1.2.840.113549.1.9.4');
		attrValues: (Set with: textDigest);
		yourself.
	signerInfo signedAttrs add: attr.
	attr := CMSAttribute new
		attrType: (ASN1ObjectId fromString: '1.2.840.113549.1.9.5');
		attrValues: (Set with: DateAndTime now);
		yourself.
	signerInfo signedAttrs add: attr.
	attr := CMSAttribute new
		attrType: (ASN1ObjectId fromString: '1.3.6.1.4.1.311.16.4');
		attrValues: (Set with: (ASN1Stream decodeBytes: (ASN1Stream 
			encode: signerInfo sid 
			withType: ((ASN1Module name: #cms) find: #SignerIdentifier))));
		yourself.
	signerInfo signedAttrs add: attr.
	attr := CMSAttribute new
		attrType: (ASN1ObjectId fromString: '1.2.840.113549.1.9.16.2.11');
		attrValues: (Set with: (ASN1ExplicitContextValue new
			tagIndex: 0;
			tagValue: (ASN1Stream decodeBytes: (ASN1Stream 
				encode: signerInfo sid 
				withType: ((ASN1Module name: #cms) find: #SignerIdentifier)));
			tagIsPrimitive: false;
			yourself));
		yourself.
	signerInfo signedAttrs add: attr.
	signerInfo signatureAlgorithm: (X509AlgorithmIdentifier oidString: '1.2.840.113549.1.1.1' parameters: ASN1Null new).

	"Compute the Signature"
	signedAttrsDer := (ASN1Stream 
		encode: signerInfo signedAttrs
		withType: ((ASN1Module name: #cms) find: #SignedAttributes)).
	signedAttrsDer at: 1 put: 49.
	signedDigest := SHA1 hashMessage: signedAttrsDer.
	signedDigest := OrderedCollection new
		add: (OrderedCollection new 
			add: (ASN1ObjectId fromString: '1.3.14.3.2.26'); 
			add: nil; 
			yourself);
		add: signedDigest;
		asAsn1Bytes.
	signerInfo signature: (self certStore ownerPrivateKey v15SignMessageHash: signedDigest).

	signedData := CMSSignedData new.
	signedData version: 1.
	signedData digestAlgorithms: (Set with: (X509AlgorithmIdentifier oidString: '1.3.14.3.2.26' parameters: ASN1Null new)).
	signedData encapContentInfo: (CMSEncapsulatedContentInfo new
		eContentType: (ASN1ObjectId fromString: '1.2.840.113549.1.7.1');
		yourself).
	signedData certificates: (OrderedSet withAll: self certStore ownerCerts).
	signedData signerInfos: (Set with: signerInfo).

	contentInfo := CMSContentInfo new
		contentType: (ASN1ObjectId fromString: '1.2.840.113549.1.7.2');
		content: signedData;
		yourself.
	^ contentInfo! !

Object subclass: #SMIMECertificateStore
	instanceVariableNames: 'storeData password rootCertificates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME'!

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:36'!
atEmail: email

	^ self storeData certificateMap at: email ifAbsent: [OrderedCollection new].
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:37'!
atEmail: email putCerts: certs

	self storeData certificateMap at: email put: certs.
	self writeStoreData.
! !

!SMIMECertificateStore methodsFor: 'reading/writing' stamp: 'rww 4/19/2007 10:36'!
certStoreFilename

	^ 'certificates/smimecert.store'! !

!SMIMECertificateStore methodsFor: 'initialize-release' stamp: 'rww 4/19/2007 10:39'!
initialize

	(FileStream isAFileNamed: self certStoreFilename)
		ifFalse: [
			(FileDirectory default directoryExists: 'certificates')
				ifFalse: [FileDirectory default createDirectory: 'certificates'].
			((FileDirectory default directoryNamed: 'certificates') directoryExists: 'roots')
				ifFalse: [(FileDirectory default directoryNamed: 'certificates') createDirectory: 'roots'].
			self storeData: SMIMECertificateStoreData new.
			self writeStoreData].
	self readStoreData.
	self rootCertificates: OrderedCollection new.
	self loadRootCertificates.
! !

!SMIMECertificateStore methodsFor: 'reading/writing' stamp: 'rww 4/19/2007 08:37'!
loadPkcs12PrivateKeyFile: filename

	| keyFileReader |
	keyFileReader := Pkcs12PrivateKeyFileReader 
		fromFile: filename 
		password: (FillInTheBlank requestPassword: 'Enter the pkcs12 password:').
	self ownerPrivateKey: keyFileReader asPrivateKey.
	self ownerCerts: keyFileReader certs.
! !

!SMIMECertificateStore methodsFor: 'reading/writing' stamp: 'rww 4/19/2007 10:55'!
loadRootCertificates

	| rootDir |
	rootDir := (FileDirectory default directoryNamed: 'certificates') directoryNamed: 'roots'.
	rootDir fileNames do: [:eachFile | 
		[self rootCertificates add: (X509CertificateDerReader fromFile: (rootDir fullNameFor: eachFile)) asCertificate] 
			on: Error 
			do: [:ex | nil]]
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:45'!
ownerCert

	^ self ownerCerts first.
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:42'!
ownerCerts

	^ self storeData ownerCertificateList
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 22:04'!
ownerCerts: certs

	self storeData ownerCertificateList: certs.
	self writeStoreData.
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 22:03'!
ownerPrivateKey

	^ (self storeData ownerPrivateKey decryptWithPassword: self password) asPrivateKey.
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 22:04'!
ownerPrivateKey: pk

	| pki epki asn1 cipher |
	pki := Pkcs8PrivateKeyInfo new
		version: 0;
		privateKeyAlgorithm: (X509AlgorithmIdentifier new
			oid: (ASN1ObjectId fromString: '1.2.840.113549.1.7.1'));
		privateKey: (ASN1Stream encode: ((Array new: 9 withAll: 0)
			at: 5 put: pk p;
			at: 6 put: pk q;
			at: 7 put: pk dP;
			at: 8 put: pk dQ;
			at: 9 put: pk qInv;
			yourself));
		yourself.
	epki := Pkcs8EncryptedPrivateKeyInfo new
		encryptionAlgorithm: (X509AlgorithmIdentifier new
			oid: (ASN1ObjectId fromString: '1.2.840.113549.1.12.1.3');
			parameters: (OrderedCollection 
				with: (SecureRandom new nextBytes: 8) 
				with: 2000)
			yourself);
		yourself.
	asn1 := ASN1Stream 
		encode: pki
		withType: ((ASN1Module name: #pkcs) find: #KeyBag).
	cipher := epki cipherWithPassword: self password.
	epki encryptedData: (cipher encrypt: asn1).

	self storeData ownerPrivateKey: epki
	self writeStoreData.
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:45'!
ownerPublicKey

	^ self ownerCert tbsCertificate subjectPublicKeyInfo asPublicKey.
! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 21:53'!
password
	"Answer the value of password"

	password isNil 
		ifTrue: [
			password := FillInTheBlank requestPassword: 'Enter the certificate store password:'].
	^ password! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:13'!
password: anObject
	"Set the value of password"

	password := anObject! !

!SMIMECertificateStore methodsFor: 'reading/writing' stamp: 'rww 4/19/2007 10:07'!
readStoreData

	| refStream |
	refStream := ReferenceStream fileNamed: self certStoreFilename.
	self storeData: refStream next.
	refStream close.

! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/19/2007 10:38'!
rootCertificates
	"Answer the value of rootCertificates"

	^ rootCertificates! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/19/2007 10:38'!
rootCertificates: anObject
	"Set the value of rootCertificates"

	rootCertificates := anObject! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:13'!
storeData
	"Answer the value of storeData"

	^ storeData! !

!SMIMECertificateStore methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:13'!
storeData: anObject
	"Set the value of storeData"

	storeData := anObject! !

!SMIMECertificateStore methodsFor: 'reading/writing' stamp: 'rww 4/19/2007 10:07'!
writeStoreData

	| refStream |
	refStream := ReferenceStream fileNamed: self certStoreFilename.
	refStream nextPut: self storeData.
	refStream close.

! !

Object subclass: #SMIMECertificateStoreData
	instanceVariableNames: 'ownerCertificateList ownerPrivateKey certificateMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMIME'!

!SMIMECertificateStoreData methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:12'!
certificateMap
	"Answer the value of certificateMap"

	^ certificateMap! !

!SMIMECertificateStoreData methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:12'!
certificateMap: anObject
	"Set the value of certificateMap"

	certificateMap := anObject! !

!SMIMECertificateStoreData methodsFor: 'initialize-release' stamp: 'rww 4/19/2007 10:36'!
initialize

	self ownerCertificateList: OrderedCollection new.
	self certificateMap: Dictionary new.
! !

!SMIMECertificateStoreData methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:12'!
ownerCertificateList
	"Answer the value of ownerCertificateList"

	^ ownerCertificateList! !

!SMIMECertificateStoreData methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:12'!
ownerCertificateList: anObject
	"Set the value of ownerCertificateList"

	ownerCertificateList := anObject! !

!SMIMECertificateStoreData methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:12'!
ownerPrivateKey
	"Answer the value of ownerPrivateKey"

	^ ownerPrivateKey! !

!SMIMECertificateStoreData methodsFor: 'accessing' stamp: 'rww 4/18/2007 11:12'!
ownerPrivateKey: anObject
	"Set the value of ownerPrivateKey"

	ownerPrivateKey := anObject! !

!Duration methodsFor: '*smime-printing' stamp: 'rww 4/21/2007 09:28'!
printOffset

	| aStream h m |
	aStream := '' writeStream.
	h _ self hours abs.
	m _ self minutes abs.
	self negative ifTrue: [ aStream nextPut: $- ].
	h < 10 ifTrue: [ aStream nextPut: $0. ].
	h printOn: aStream.
	m < 10 ifTrue: [ aStream nextPut: $0. ].
	m printOn: aStream.
	^ aStream contents! !

!MIMEHeaderValue methodsFor: '*smime' stamp: 'rww 4/23/2007 18:25'!
asHeaderValue
	| strm |
	strm _ WriteStream on: (String new: 20).
	strm nextPutAll: mainValue.
	parameters associationsDo: [:e | 
		strm nextPut: $; ;
		cr; tab; 
		nextPutAll: e key;
		nextPutAll: '="';
		nextPutAll: e value;
		nextPut: $"].
	^ strm contents! !

!MailMessage methodsFor: '*smime' stamp: 'rww 4/22/2007 09:43'!
from: aString 
	"Parse aString to initialize myself."

	| parseStream contentType bodyText contentTransferEncoding |

	tokens _ nil.
	text := aString.
	parseStream _ ReadStream on: text.
	contentType _ 'text/plain'.
	contentTransferEncoding _ nil.
	fields := Dictionary new.

	"Extract information out of the header fields"
	self fieldsFrom: parseStream do: 
		[:fName :fValue | 
		"NB: fName is all lowercase"

		fName = 'content-type' ifTrue: [contentType _ (fValue copyUpTo: $;) asLowercase].
		fName = 'content-transfer-encoding' ifTrue: [contentTransferEncoding _ fValue asLowercase].

		(fields at: fName ifAbsentPut: [OrderedCollection new: 1])
			add: (MIMEHeaderValue forField: fName fromString: fValue)].

	"Extract the body of the message"
	bodyText _ parseStream upToEnd.
	contentTransferEncoding = 'base64'
		ifTrue: 
			[bodyText _ Base64MimeConverter mimeDecodeToChars: (ReadStream on: bodyText).
			bodyText _ bodyText contents].
	contentTransferEncoding = 'quoted-printable' ifTrue: [bodyText _ QuotedPrintableMimeConverter  mimeDecode: bodyText as: String].
	body _ MIMEDocument contentType: contentType content: bodyText! !

!MailMessage methodsFor: '*smime' stamp: 'rww 4/22/2007 09:43'!
parseParts
	"private -- parse the parts of the message and store them into a collection"

	| parseStream msgStream messages separator |

	"If this is not multipart, store an empty collection"
	self body isMultipart ifFalse: [parts _ #().  ^self].

	"If we can't find a valid separator, handle it as if the message is not multipart"
	separator := self attachmentSeparator.
	separator ifNil: [Transcript show: 'Ignoring bad attachment separater'; cr. parts _ #(). ^self].

	separator := '--', separator withoutTrailingBlanks.
	parseStream _ ReadStream on: self bodyText.

	msgStream _ LimitingLineStreamWrapper on: parseStream delimiter: separator.
	msgStream limitingBlock: [:aLine |
		aLine withoutTrailingBlanks = separator or:			"Match the separator"
		[aLine withoutTrailingBlanks = (separator, '--')]].	"or the final separator with --"

	"Throw away everything up to and including the first separator"
	msgStream upToEnd.
	msgStream skipThisLine.

	"Extract each of the multi-parts as strings"
	messages _ OrderedCollection new.
	[parseStream atEnd]
		whileFalse: 
			[messages add: msgStream upToEnd.
			msgStream skipThisLine].

	parts _ messages collect: [:e | MailMessage from: (e copyFrom: 1 to: e size - 1)]! !

!MailMessage methodsFor: '*smime' stamp: 'rww 4/15/2007 17:31'!
parts: theParts

	parts := theParts asArray.
! !

!DateAndTime methodsFor: '*smime-printing' stamp: 'rww 4/21/2007 09:30'!
printMIMEDayDateAndTime

	^ self dayOfWeekAbbreviation, 
		', ', 
		(self asDate printFormat: #(1 2 3 $  2 1)), 
		' ', 
		self asTime print24, 
		' ', 
		self offset printOffset.
! !
CMSContentInfo initialize!
